/*
 * Copyright (c) 2010, Koji Tsukada<tsuka@mobiquitous.com> 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace MobiServer.Devices.Xbee
{
    public class DataServer : MobiServer.DataBase
    {
        public const string HeaderXbee = "Xbee";

        string state;
        string address;
        string type;
        int port;
        int data;

        public class Types
        {
            public const string Analog = "Analog";
            public const string Digital = "Digital";
        }
        
        public DataServer(string state, string address, string type, int port, int data)
            : base(HeaderXbee)
        {
         
            this.state = state;
            this.address = address;
            this.type = type;
            this.port = port;
            this.data = data;
        }

        public DataServer(string state, string address, string type, int port, bool data)
            : base(HeaderXbee)
        {
            this.state = state;
            this.address = address;
            this.type = type;
            this.port = port;
            if (data)
                this.data = 1;
            else
                this.data = 0;
        }

        public DataServer(string state, string address)
        {
            this.state = state;
            this.address = address;
        }

        public string State
        {
            get { return this.state; }
        }

        public string Address
        {
            get { return this.address; }
        }

        public string Type
        {
            get { return this.type; }
        }

        public int Port
        {
            get { return this.port; }
        }

        public int Data
        {
            get { return this.data; }
        }

        public string[] ToArray()
        {
            string[] args = null;

            switch(State){
                case States.Attach:
                case States.Dettach:
                    args = new string[3] { Header, State, Address};
                    break;
                case States.In:
               
                    args = new string[6] { Header, State, Address, Type, Port.ToString(), Data.ToString()};
                    break;
                //case States.Out:
                    
            }
            return args;
        }


        //Parse strings from TCP Server
        //(Not worked yet)
        static public DataServer Parse(string[] args)
        {
            try
            {
                DataServer b = null;
                
                if(args[0] != Header)
                    return null;

                return b;
            }
            catch (Exception ex)
            {
                return null;
            }

        }
    }
}

