﻿/*
 * Copyright (c) 2010, Koji Tsukada<tsuka@mobiquitous.com> 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Net;
using System.IO;
using System.Threading;
using System.Net.Sockets;

namespace MobiServer
{

    public partial class MainForm : System.Windows.Forms.Form
    {
        Size panelXbeeSize = Size.Empty;
        public MainForm()
        {
            InitializeComponent();
            InitPanelXbee();
            System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = false;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            serverControl.MessageControl = messageControl;

        }

        void InitPanelXbee()
        {
            this.panelXbee = new MobiServer.Devices.Xbee.ControlPanel(serverControl, messageControl);
            this.panelXbee.Location = new System.Drawing.Point(1, 114);
            this.panelXbee.Name = "panelXbee";
            this.panelXbee.Size = new System.Drawing.Size(655, 122);
            this.panelXbee.TabIndex = 2;
            this.panelXbee.Resize += new System.EventHandler(this.panelXbee_Resize);
            this.Controls.Add(this.panelXbee);

            panelXbeeSize = panelXbee.Size;
        }

        private void panelXbee_Resize(object sender, EventArgs e)
        {          
            this.Height += panelXbee.Height - panelXbeeSize.Height;
            this.Width += panelXbee.Width - panelXbeeSize.Width;
            panelXbeeSize = panelXbee.Size;
        }
    }
}
